#include<stdio.h>
typedef struct{
	unsigned d,p;
}dan;
main (){
	unsigned n,x,q,s=0,st=0,i,j,pit[100],dd; dan niz[1000];
	scanf("%u%u",&n,&q);
	for(i=0;i<n;i++){
		scanf("%u%u",&niz[i].d,&niz[i].p);
	}
	for(j=0;j<q;j++){
		scanf("%u",&pit[j]);
	}
	for(i=0; i<q; i++){
		dd=pit[i];
		s=0;
		x=0;
		st=0;
		for(j=1; j<=dd; j++){
			if(j==niz[x].d){
				st+=niz[x].p;
				x++;}
			if(st>0){
				st--;
				s++;
			}
		}
		printf("%u\n",s);
	}
}